#!/usr/bin/env python3
# coding: utf-8

from binascii import crc32
from threading import Thread

from wxpy.api.chats import FEMALE, MALE

emojis = \
    '😃🐻🍔⚽🌇💡🔣🎌💌🙈🙉🙊💥💦💨💫🐵🐒🦍🐶🐕🐩🐺🦊🐱🐈🦁🐯🐅🐆🐴🐎🦄🐮🐂🐃🐄🐷🐖🐗' \
    '🐽🐏🐑🐐🐪🐫🐘🦏🐭🐁🐀🐹🐰🐇🐿🦇🐨🐼🐾🦃🐔🐓🐣🐤🐥🐦🐧🕊🦅🦆🦉🐸🐊🐢🦎🐍🐲🐉🐳🐋' \
    '🐬🐟🐠🐡🐙🐚🦀🦐🦑🐌🦋🐛🐜🐝🐞🕷🕸🦂💐🌸💮🏵🌹🥀🌺🌻🌼🌷🌱🌲🌳🌴🌵🌾🌿☘🍀🍁🍂🍃' \
    '🍄🌰🌍🌎🌏🌐🌑🌒🌓🌔🌕🌖🌗🌘🌙🌚🌛🌜☀🌝🌞⭐🌟🌠☁⛅⛈🌤🌥🌦🌧🌨🌩🌪🌫🌬🌈☂☔⚡' \
    '❄☃⛄☄🔥💧🌊🎄✨🎋🎍🤷😂❤😍😊🤔😘🙄📲🚻👀💻✊📝🎇🎂🛍🎅🎥👨💪🎓🎃🕎🕉👩🎊🏊👑' \
    '☪🏈💘👰🎿🍇🍈🍉🍊🍋🍌🍍🍎🍏🍐🍑🍒🍓🥝🍅🥑🍆🥔🥕🌽🌶🥒🥜🍞🥐🥖🥞🧀🍖🍗🥓🍟🍕🌭🌮' \
    '🌯🍳🍲🥗🍿🍱🍘🍙🍚🍛🍜🍝🍠🍢🍣🍤🍥🍡🍦🍧🍨🍩🍪🍰🍫🍬🍭🍮🍯🍼🥛☕🍵🍶🍾🍷🍸🍹🍺🍻' \
    '🥂🥃🍽🍴🥄👾🕴🏇⛷🏂🏌🏄🚣⛹🏋🚴🚵🤸🤼🤽🤾🤹🎪🎭🎨🎰🎗🎟🎫🎖🏆🏅🥇🥈🥉⚾🏀🏐🏉🎾' \
    '🎱🎳🏏🏑🏒🏓🏸🥊🥋🎯⛳⛸🎣🎽🎮🎲🎼🎤🎧🎷🎸🎹🎺🎻🥁🎬🏹🏎🏍🗾🏔⛰🌋🗻🏕🏖🏜🏝🏞🏟' \
    '🏛🏗🏘🏙🏚🏠🏡🏢🏣🏤🏥🏦🏨🏩🏪🏫🏬🏭🏯🏰💒🗼🗽⛪🕌🕍⛩🕋⛲⛺🌁🌃🌄🌅🌆🌉🌌🎠🎡🎢' \
    '🚂🚃🚄🚅🚆🚇🚈🚉🚊🚝🚞🚋🚌🚍🚎🚐🚑🚒🚓🚔🚕🚖🚗🚘🚚🚛🚜🚲🛴🛵🚏🛤⛽🚨🚥🚦🚧⚓⛵🚤' \
    '🛳⛴🛥🚢✈🛩🛫🛬💺🚁🚟🚠🚡🛰🚀⛱🎆🎑💴💵💶💷🗿🛂🛃🛄🛅☠🛀🛌💣🕳📿💎🔪🏺🗺💈🖼🛎' \
    '🚪🛏🛋🚽🚿🛁⌛⏳⌚⏰⏱⏲🕰🌡🎈🎉🎎🎏🎐🎀🎁🕹📯🎙🎚🎛📻📱☎📞📟📠🔋🔌🖥🖨⌨🖱🖲💽' \
    '💾💿📀🎞📽📺📷📸📹📼🔍🔎🔬🔭📡🕯🔦🏮📔📕📖📗📘📙📚📓📃📜📄📰🗞📑🔖🏷💰💸💳✉📧📨' \
    '📩📤📥📦📫📪📬📭📮🗳✏✒🖋🖊🖌🖍📁📂🗂📅📆🗒🗓📇📈📉📊📋📌📍📎🖇📏📐✂🗃🗄🗑🔒🔓' \
    '🔏🔐🔑🗝🔨⛏⚒🛠🗡⚔🔫🛡🔧🔩⚙🗜⚗⚖🔗⛓💉💊🚬⚰⚱🛢🔮🚰🏁🚩🏴🏳'


def assign_emoji(chat):
    n = crc32(str(chat.wxid or chat.nick_name).encode()) & 0xffffffff
    return emojis[n % len(emojis)]


def msg_prefix(user):
    # represent avatar
    member_prefix = assign_emoji(user)

    # represent sex
    if user.sex is MALE:
        user_suffix = '\U0001f454'
    elif user.sex is FEMALE:
        user_suffix = '\U0001f380'
    else:
        user_suffix = '\U0001f60e'

    return '{} · {} · {}'.format(member_prefix, user.name, user_suffix)


def sync_message_in_groups(
        msg, groups, prefix=None, suffix=None,
        raise_for_unsupported=False, run_async=True
):
    """
    将消息同步到多个微信群中

    支持以下消息类型
        * 文本 (`TEXT`)
        * 视频（`VIDEO`)
        * 文件 (`ATTACHMENT`)
        * 图片/自定义表情 (`PICTURE`)

            * 但不支持表情商店中的表情

        * 名片 (`CARD`)

            * 仅支持公众号名片

        * 分享 (`SHARING`)

            * 会被转化为 `标题 + 链接` 形式的纯文本

        * 语音 (`RECORDING`)

            * 会以文件方式发送

    :param Message msg: 需同步的消息对象
    :param Group groups: 需同步的群列表
    :param str prefix:
        * 转发时的 **前缀** 文本，原消息为文本时会自动换行
        * 若不设定，则使用默认前缀作为提示
    :param str suffix:
        * 转发时的 **后缀** 文本，原消息为文本时会自动换行
        * 默认为空
    :param bool raise_for_unsupported:
        | 为 True 时，将为不支持的消息类型抛出 `NotImplementedError` 异常
    :param bool run_async: 是否异步执行，为 True 时不堵塞线程


    ::

        my_groups = [group1, group2, group3 ...]

        @bot.register(my_groups, except_self=False)
        def sync_my_groups(msg):
            sync_message_in_groups(msg, my_groups)

    """

    def process():
        for group in groups:
            if group == msg.chat:
                continue

            msg.forward(
                chat=group, prefix=prefix, suffix=suffix,
                raise_for_unsupported=raise_for_unsupported
            )

    if prefix is None:

        member = msg.member

        member_prefix = assign_emoji(member)

        if member.sex is MALE:
            member_suffix = '\U0001f454'
        elif member.sex is FEMALE:
            member_suffix = '\U0001f380'
        else:
            member_suffix = '\U0001f60e'

        prefix = '{} · {} · {}'.format(member_prefix, member.name, member_suffix)

    if run_async:
        Thread(target=process, daemon=True).start()
    else:
        process()
